program gq_cc2_plot

version 10

display
display as text ". CC plot resumed"
display

/*seleccion de variables, "out" aborta el programa, "pause" lo para*/

if $legend==1 {
	local legend "legend(on cols(1)) legend(position(3))"
	}
	else{
	local legend "legend (off)"
	}

local fin=0/*variable de control 1*/
local to_plot=""
while `fin'==0{/*1 loop principal*/
	
	local sample_id "junk"
	if "`sample_id '"=="out" {
		local fin=1
		}
	capture confirm numeric variable `sample_id'
	while _rc!=0 & `fin'==0 { /*2*/
		display as result". Sample to plot? (use the variables window) "_cont
		display _request(_sample_id )
		capture confirm numeric variable `sample_id'
		if _rc==0 {
			local to_plot="`to_plot'"+" "+"`sample_id '"
			}
		if "`sample_id '"=="out" | "`sample_id '"=="pause" {
				local fin=1
				}
		else{
		  if _rc==0{
			twoway (connected `to_plot' el), ytitle(rock/continental crust, size(vlarge)) yscale(log) yscale(titlegap(2)) yscale(range(0.05 30)) ylabel(0.1 1 10, labsize(large)) ymlabel(0.05 0.06 0.07 0.08 0.09 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1 2 3 4 5 6 7 8 9 10 20,nolabels) xtitle("") xscale(range(1 14)) xlabel(1(1)14, valuelabel labsize(large) alternate) title(Continental Crust-normalized plot, size(large)) `legend' plotregion(lcolor(black)) xsize($a_xsize) ysize(4)	name("cc_plot", replace)	
			local to_plot=""
			display
			display as result "NEW ENTRY"
			display
			}/*del ultimo if*/
			}
	}/*del while 2*/		
}/*del while 1*/

if "`sample_id '"=="out" {
	local myfile=(c(filename))
	use "`myfile'", clear
	global is_changed=0/*xsize*/
	display
	display as text". Done CC plot"
	}
	else
if "`sample_id '"=="pause" {
	display
	display as text". Paused CC plot; to resume type" as error" -resume-"
	global resume="gq_cc2_plot"
	}
end
