program gq_tas_plot

version 10

if $is_changed==0 global a_xsize=5		

display""
display""
display""
display as text". TOTAL ALKALIS vs. SILICA PLOT, by F. Bea (2008); v. 3.01"
display""
	

display ""
display ""

display""					

//*calculo del numero de grupos y labels diferentes*/
quietly {
capture drop orden
gen orden=_n
sort label
capture drop type
gen type=.
replace type=1 in 1
local n=_N
local ng=1
local t1=label[1]
forvalues i=2(1)`n' {
				local c1=`i'-1
				replace type=`ng' in `i'
				if label[`i']!=label[`c1'] {
					local ng=`ng'+1
					local t`ng'= label[`i']
					replace type=`ng' in `i'
					}
				}	
replace type=6969 if label=="ZZ" /*exclusion del grupo labeled ZZ*/
local mute=0
forvalues i=2(1)`n' {
	if label[`i']=="ZZ" local mute=1
	}
if `mute'==1 local ng=`ng'-1				
sort orden
drop orden
}
/*fin*/

/*crea la leyenda*/
if `ng'==1 local leyenda "3 "`t1'""
if `ng'==2 local leyenda "3 "`t1'" 4 "`t2'""
if `ng'==3 local leyenda "3 "`t1'" 4 "`t2'" 5 "`t3'""
if `ng'==4 local leyenda "3 "`t1'" 4 "`t2'" 5 "`t3'" 6 "`t4'""
if `ng'==5 local leyenda "3 "`t1'" 4 "`t2'" 5 "`t3'" 6 "`t4'" 7 "`t5'""
if `ng'==6 local leyenda "3 "`t1'" 4 "`t2'" 5 "`t3'" 6 "`t4'" 7 "`t5'" 8 "`t6'""
if `ng'==7 local leyenda "3 "`t1'" 4 "`t2'" 5 "`t3'" 6 "`t4'" 7 "`t5'" 8 "`t6'" 9 "`t7'""
/*fin*/

capture drop xcoor ycoor



/*calculo de las coordenadas*/
quietly{
gen xcoor=si
gen ycoor=na+k
}/*del quietly*/



/*comprueba si los puntos estn dentro del rango de coordenadas*/ 
local n=_N
forvalues i=1(1)`n'{

				if xcoor[`i']<39  {
				display as error ". sample " id[`i'] " has SiO2 < 39"
				quietly {
					replace type=. in `i'
						}
					}
				if xcoor[`i']>76 {
				display as error ". sample " id[`i'] " has SiO2 > 76"
				quietly {
					replace type=. in `i'
						}
					}
				if ycoor[`i']<0 {
				display as error ". sample " id[`i'] " has Na2O+K2O < 0"
				quietly {
					replace type=. in `i'
						}
					}
				if ycoor[`i']>16 {
				display as error ". sample " id[`i'] " has Na2O+K2O > 16"
				quietly {
					replace type=. in `i'
						}
					}										
	} /*del for	*/
	
	
/*crea los puntos para dibujar la plantilla*/	
quietly{
local n=_N
local nn=`n'+36
set obs `nn'
local i= `n'+1
replace xcoor= 69 in `i'
replace ycoor= 8 in `i'
replace type=0 in `i'
local i= `n'+2
replace xcoor= 75 in `i'
replace ycoor= 1.2 in `i'
replace type=0 in `i'
local i= `n'+3
replace xcoor= 69 in `i'
replace ycoor=8 in `i'
replace type=0 in `i'
local i= `n'+4
replace xcoor=69 in `i'
replace ycoor=13.5 in `i'
replace type=0 in `i'
local i= `n'+5
replace xcoor= 63 in `i'
replace ycoor= 6.95 in `i'
replace type=0 in `i'
local i= `n'+6
replace xcoor= 63 in `i'
replace ycoor= 1 in `i'
replace type=0 in `i'
local i= `n'+7
replace xcoor= 52 in `i'
replace ycoor= 5 in `i'
replace type=0 in `i'
local i= `n'+8
replace xcoor= 69 in `i'
replace ycoor= 8 in `i'
replace type=0 in `i'
local i= `n'+9
replace xcoor= 57.5 in `i'
replace ycoor= 11.7 in `i'
replace type=0 in `i'
local i= `n'+10
replace xcoor= 63 in `i'
replace ycoor= 6.95 in `i'
replace type=0 in `i'
local i= `n'+11
replace xcoor= 50 in `i'
replace ycoor= 15.2 in `i'
replace type=0 in `i'
local i= `n'+12
replace xcoor= 57.5 in `i'
replace ycoor= 11.7 in `i'
replace type=0 in `i'
local i= `n'+13
replace xcoor= 57 in `i'
replace ycoor= 5.85 in `i'
replace type=0 in `i'
local i= `n'+14
replace xcoor= 57 in `i'
replace ycoor= 1 in `i'
replace type=0 in `i'
local i= `n'+15
replace xcoor= 53.1 in `i'
replace ycoor= 9.3 in `i'
replace type=0 in `i'
local i= `n'+16
replace xcoor= 57 in `i'
replace ycoor= 5.85 in `i'
replace type=0 in `i'
local i= `n'+17
replace xcoor= 45 in `i'
replace ycoor= 5 in `i'
replace type=0 in `i'
local i= `n'+18
replace xcoor= 64 in `i'
replace ycoor= 15.1 in `i'
replace type=0 in `i'
local i= `n'+19
replace xcoor= 52 in `i'
replace ycoor= 1 in `i'
replace type=0 in `i'
local i= `n'+20
replace xcoor= 52 in `i'
replace ycoor= 5 in `i'
replace type=0 in `i'
local i= `n'+21
replace xcoor= 48.5 in `i'
replace ycoor= 11.5 in `i'
replace type=0 in `i'
local i= `n'+22
replace xcoor= 53.1 in `i'
replace ycoor= 9.3 in `i'
replace type=0 in `i'
local i= `n'+23
replace xcoor= 49.3 in `i'
replace ycoor= 7.3 in `i'
replace type=0 in `i'
local i= `n'+24
replace xcoor= 52 in `i'
replace ycoor= 5 in `i'
replace type=0 in `i'
local i= `n'+25
replace xcoor= 45 in `i'
replace ycoor= 9.5 in `i'
replace type=0 in `i'
local i= `n'+26
replace xcoor= 49.3 in `i'
replace ycoor= 7.3 in `i'
replace type=0 in `i'
local i= `n'+27
replace xcoor= 41 in `i'
replace ycoor= 7 in `i'
replace type=0 in `i'
local i= `n'+28
replace xcoor= 52.5 in `i'
replace ycoor= 14 in `i'
replace type=0 in `i'
local i= `n'+29
replace xcoor= 45 in `i'
replace ycoor= 5 in `i'
replace type=0 in `i'
local i= `n'+30
replace xcoor= 52 in `i'
replace ycoor= 5 in `i'
replace type=0 in `i'
local i= `n'+31
replace xcoor= 45 in `i'
replace ycoor= 1 in `i'
replace type=0 in `i'
local i= `n'+32
replace xcoor= 45 in `i'
replace ycoor= 5 in `i'
replace type=0 in `i'
local i= `n'+33
replace xcoor= 41 in `i'
replace ycoor= 3 in `i'
replace type=0 in `i'
local i= `n'+34
replace xcoor= 45 in `i'
replace ycoor= 3 in `i'
replace type=0 in `i'
local i= `n'+35
replace xcoor= 41 in `i'
replace ycoor= 7 in `i'
replace type=0 in `i'
local i= `n'+36
replace xcoor= 41 in `i'
replace ycoor= 1 in `i'
replace type=0 in `i'
}/*del quietly*/

/*limite alk_ca+th*/
quietly {
local n=_N
local nn=`n'+ 8
set obs `nn'
local i= `n'+1
replace xcoor= 45 in `i'
replace ycoor= 2.1 in `i'
replace type=100 in `i'
local i= `n'+2
replace xcoor= 55 in `i'
replace ycoor= 5.9 in `i'
replace type=100 in `i'
local i= `n'+3
replace xcoor= 56 in `i'
replace ycoor=6.22 in `i'
replace type=100 in `i'
local i= `n'+4
replace xcoor=57 in `i'
replace ycoor=6.5 in `i'
replace type=100 in `i'
local i= `n'+5
replace xcoor= 58 in `i'
replace ycoor= 6.65 in `i'
replace type=100 in `i'
local i= `n'+6
replace xcoor= 59 in `i'
replace ycoor= 6.8 in `i'
replace type=100 in `i'
local i= `n'+7
replace xcoor= 60 in `i'
replace ycoor= 6.9 in `i'
replace type=100 in `i'
local i= `n'+8
replace xcoor= 75 in `i'
replace ycoor= 8.3 in `i'
replace type=100 in `i'

}


/*escoge si proyecta identificadores de las muestras*/
if $ids== 0 { /*no identificadores*/
	twoway (connect ycoor xcoor if type==100,lcolor(gs12) lwidth(thick) msymbol(none) mcolor(none))(scatter ycoor xcoor if type==0, msize(zero) mcolor(none)c(L) lcolor(gs12)) (scatter ycoor xcoor if type==1, msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, msymbol($symbol7) msize($size7) mcolor($color7)), ytitle(Na2O + K2O, size(vlarge)) ylabel(0(2)16, angle("$y_orientation") format(%9.0f) labsize(large)) ymlabel(0(1)16, nolabels) xtitle(SiO2, size(vlarge)) xlabel(40(5)75, format(%9.0f) labsize(large)) xmlabel(39(1)76, nolabels) title(Total Alkalis SiO2 Plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(10 57 "Alk", size(vlarge) orientation(horizontal) color(gs8)) text(2 57 "Ca + Th", size(vlarge) orientation(horizontal) color(gs8)) name("TAS_plot", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black))
	}
	else{
	twoway (connect ycoor xcoor if type==100,lcolor(gs12) lwidth(thick) msymbol(none) mcolor(none))(scatter ycoor xcoor if type==0, msize(zero) mcolor(none)c(L)lcolor(gs12)) (scatter ycoor xcoor if type==1, mlabel(id) mlabcolor(black) msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, mlabel(id) mlabcolor(black) msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, mlabel(id) mlabcolor(black) msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, mlabel(id) mlabcolor(black) msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, mlabel(id) mlabcolor(black) msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, mlabel(id) mlabcolor(black) msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, mlabel(id) mlabcolor(black) msymbol($symbol7) msize($size7) mcolor($color7)), ytitle(Na2O + K2O, size(vlarge)) ylabel(0(2)16, angle("$y_orientation") format(%9.0f) labsize(large)) ymlabel(0(1)16, nolabels) xtitle(SiO2, size(vlarge)) xlabel(40(5)75, format(%9.0f) labsize(large)) xmlabel(39(1)76, nolabels) title(Total Alkalis SiO2 Plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(10 57 "Alk", size(vlarge) orientation(horizontal) color(gs8)) text(2 57 "Ca + Th", size(vlarge) orientation(horizontal) color(gs8)) name("labeled_TAS_plot", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black))
}/*del if*/
global is_changed=0/*xsize*/
quietly{
	drop if type==0
	drop xcoor ycoor
	drop if type==0 | type==100
	drop type
	}
display
display as text ". Done TAS plot"

end
