program gq_bi_plot

version 10

display
display
display
display as text". BINARY PLOTS, by F. Bea (2008); v. 3.01"
display
display as text ". To stop plotting, type " as error "out" as text " as Y coordinate"
display as text". If you want a bisectriz, stop plotting and go to the menu" 


display
display

if $is_changed==0 global a_xsize=5				

/*calculo del numero de grupos y labels diferentes*/
quietly {
capture drop orden
gen orden=_n
sort label
capture drop type
gen type=.
replace type=1 in 1
local n=_N
local ng=1
local t1=label[1]
forvalues i=2(1)`n' {
				local c1=`i'-1
				replace type=`ng' in `i'
				if label[`i']!=label[`c1'] {
					local ng=`ng'+1
					local t`ng'= label[`i']
					replace type=`ng' in `i'
					}
				}
replace type=6969 if label=="ZZ" /*exclusion del grupo labeled ZZ*/
local mute=0
forvalues i=2(1)`n' {
	if label[`i']=="ZZ" local mute=1
	}
if `mute'==1 local ng=`ng'-1				
sort orden
drop orden
}
/*fin*/

/*crea la leyenda*/
if `ng'==1 local leyenda "1 "`t1'""
if `ng'==2 local leyenda "1 "`t1'" 2 "`t2'""
if `ng'==3 local leyenda "1 "`t1'" 2 "`t2'" 3 "`t3'""
if `ng'==4 local leyenda "1 "`t1'" 2 "`t2'" 3 "`t3'" 4 "`t4'""
if `ng'==5 local leyenda "1 "`t1'" 2 "`t2'" 3 "`t3'" 4 "`t4'" 5 "`t5'""
if `ng'==6 local leyenda "1 "`t1'" 2 "`t2'" 3 "`t3'" 4 "`t4'" 5 "`t5'" 6 "`t6'""
if `ng'==7 local leyenda "1 "`t1'" 2 "`t2'" 3 "`t3'" 4 "`t4'" 5 "`t5'" 6 "`t6'" 7 "`t7'""
/*fin*/


/*seleccion de variables, "out" aborta el programa*/
local sigo 0 /*variable de control*/
while `sigo' ==0 {
	local ycoor "junk"
	capture confirm numeric variable `ycoor'
	if "`ycoor'"=="out" local sigo=1
	while _rc!=0 & `sigo'==0 {
		display as result ". Y coordinate? (type or double-click in the variables window) " _cont
		display _request(_ycoor)
		if wordcount("`ycoor'")!=1 local ycoor="caca" /*evito dos variables*/
		capture confirm numeric variable `ycoor'
		if "`ycoor'"=="out" local sigo=1
		}
	local xcoor "jank"
	capture confirm numeric variable `xcoor'
	while _rc!=0 & `sigo'==0{
		display as result ". X coordinate? (type or double-click in the variables window) " _cont
		display _request(_xcoor)
		capture confirm numeric variable `xcoor'
						
		quietly{/*intervalo de coordenadas X para proyectar la funcin*/
		sum `xcoor' if label!="ZZ"
		local xmin=r(min)
		local xmax=r(max)
		local y_lab=""
		local x_lab=""
		local y_lab: var l `ycoor'
		local x_lab: var l `xcoor'
		if "`y_lab'" =="" local y_lab="`ycoor'"
		if "`x_lab'"=="" local x_lab="`xcoor'"
		}/*del quietly*/
		}/*del while*/
	if $bisectriz==1 {
		local hago_bisectriz="(function y=x, range(`xmin' `xmax'))"
		}
		else{
		local hago_bisectriz=""
		}/*del if*/

	/*escoge si proyecta identificadores de las muestras*/
	if "`ycoor'"!="out" {
	if $ids== 0 { /*no identificadores*/
		twoway (scatter `ycoor' `xcoor' if type==1, msymbol($symbol1) msize($size1) mcolor($color1)) (scatter `ycoor' `xcoor' if type==2, msymbol($symbol2) msize($size2) mcolor($color2))(scatter `ycoor' `xcoor' if type==3, msymbol($symbol3) msize($size3) mcolor($color3))(scatter `ycoor' `xcoor' if type==4, msymbol($symbol4) msize($size4) mcolor($color4))(scatter `ycoor' `xcoor' if type==5, msymbol($symbol5) msize($size5) mcolor($color5)) (scatter `ycoor' `xcoor' if type==6, msymbol($symbol6) msize($size6) mcolor($color6)) (scatter `ycoor' `xcoor' if type==7, msymbol($symbol7) msize($size7) mcolor($color7)) `hago_bisectriz', ylabel(, angle("$y_orientation") labsize(large)) xlabel(, labsize(large)) ytitle("`y_lab'", size(vlarge)) xtitle("`x_lab'", size(vlarge)) title(binary scatter plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) ysize(4) xsize($a_xsize) name("scatter_plot", replace) plotregion(lcolor(black))
		}
	else{
		twoway (scatter `ycoor' `xcoor' if type==1, mlabel(id) mlabcolor(black) msymbol($symbol1) msize($size1) mcolor($color1)) (scatter `ycoor' `xcoor' if type==2, mlabel(id) mlabcolor(black) msymbol($symbol2) msize($size2) mcolor($color2))(scatter `ycoor' `xcoor' if type==3, mlabel(id) mlabcolor(black) msymbol($symbol3) msize($size3) mcolor($color3))(scatter `ycoor' `xcoor' if type==4, mlabel(id) mlabcolor(black) msymbol($symbol4) msize($size4) mcolor($color4))(scatter `ycoor' `xcoor' if type==5, mlabel(id) mlabcolor(black) msymbol($symbol5) msize($size5) mcolor($color5)) (scatter `ycoor' `xcoor' if type==6, mlabel(id) mlabcolor(black) msymbol($symbol6) msize($size6) mcolor($color6)) (scatter `ycoor' `xcoor' if type==7, mlabel(id) mlabcolor(black) msymbol($symbol7) msize($size7) mcolor($color7)) `hago_bisectriz',xlabel(,labsize(large)) ylabel(, angle("$y_orientation") labsize(large)) ytitle(`y_lab', size(vlarge)) xtitle(`x_lab', size(vlarge)) title(binary scatter plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150)  ysize(4) xsize($a_xsize) name("labeled_scatter_plot", replace) plotregion(lcolor(black))
		}
		local ycoor "junk"
		local xcoor "junk"
		display""
		display"NEW ENTRY"
		display""
	}/*del if*/	
}/*del primer while*/
drop type
display
global is_changed=0/*xsize*/
display as text ". Done binary plots"

end
