program gq_el_par

version 10

capture drop asi 
capture drop agpi 
capture drop femg 
capture drop cai 
capture drop kna
capture confirm numeric variable si al fe mg ca na k
if !_rc{
	gen asi=(al/101.96)/(ca/56.08+na/61.98+k/94.2)
	gen agpi=(na/61.98+k/94.2)/(al/101.96)
	gen femg=(fe/79.9)/(fe/79.9+mg/40.3)
	gen cai=(ca/56.08)/(na/61.98+k/94.2)
	gen kna=(k/94.2)/(na/61.98+k/94.2)
	}
capture drop lalu 
capture drop euanom
capture confirm numeric variable la lu eu sm nd gd
if !_rc{
	gen lalu=(la/0.237)/(lu/0.0246)
	gen euanom=(eu/0.0563)/(((sm/0.148)*(gd/0.199))^0.5)
	}
capture drop krb	
capture confirm numeric variable k rb
if !_rc{
	gen krb=8301.5*k/rb
	}		
capture drop zrhf
capture confirm numeric variable zr hf
if !_rc{
	gen zrhf=zr/hf
	}
capture drop nbta	
capture confirm numeric variable nb ta
if !_rc{
	gen nbta=nb/ta
	}
capture drop thu	
capture confirm numeric variable u th
if !_rc{
	gen thu=th/u
	}
capture drop th_pm ta_pm
capture drop thta_pm
capture confirm numeric variable ta th
if !_rc{
	gen th_pm= th/0.0795
	gen ta_pm=ta/0.037
	gen thta_pm=th_pm/ta_pm
	}
	display
	display as text ". Done element parameters"
end
