program gq_ree2_plot

version 10

if $is_changed==0 global a_xsize=6

if $legend==1 {
	local legend "legend(on cols(1)) legend(position(3))"
	}
	else{
	local legend "legend (off)"
	}


display
display as text ". REE plot resumed"
display

/*seleccion de variables, "out" aborta el programa, "pause" lo para conservando los datos*/

local fin=0/*variable de control 1*/
local to_plot=""
local fin=0
while `fin'==0{/*1 loop principal*/

	local sample_id "junk"
	if "`sample_id '"=="out" {
		local fin=1
		}

	capture confirm numeric variable `sample_id'
	while _rc!=0 & `fin'==0 { /*2*/
		display as result". Sample to plot? (use the variables window) " _cont
		display _request(_sample_id )
		capture confirm numeric variable `sample_id'
		if _rc==0 {
			local to_plot="`to_plot'"+" "+"`sample_id '"
			}
		if "`sample_id '"=="out" | "`sample_id '"=="pause" {
				local fin=1
				}
			else {
				if _rc==0{
				twoway (connected `to_plot' el), ytitle(rock/chondrite, size(vlarge)) yscale(log) yscale(titlegap(2)) ylabel(1 10 100 1000,labsize(large)) ymtick(1(1)10 20(10)100 200(100)1000) xtitle("") xlabel(1(1)4 6(1)15, valuelabel labsize(large) alternate) ysize(4) xsize($a_xsize) title(Chondrite-normalized REE plot, size(large)) `legend' plotregion(lcolor(black)) name("ree_plot", replace)		
			    local to_plot=""
				display
				display as result"NEW ENTRY"
				display
				}/*del ultimo if*/
				}
		}/*del while 2*/		
}/*del while 1*/

display""

if "`sample_id '"=="out" {
	local myfile=(c(filename))
	use "`myfile'", clear
	global is_changed=0/*xsize*/
	display
	display as text". Done REE plot"
	}
	else
if "`sample_id '"=="pause" {
	display
	display as text". Paused REE plot; to resume type" as error" -resume-"
	global resume="gq_ree2_plot"
	}
end
