program gq_tri_plot

version 10

display""
	display""
	display""
	display""
	display as text". TERNARY PLOTS by F. Bea (2008); v. 3.0"
	display""
	

/*calculo del numero de grupos y labels diferentes*/
quietly {
capture drop orden
gen orden=_n
sort label
capture drop type
gen type=.
replace type=1 in 1
local n=_N
local ng=1
local t1=label[1]
forvalues i=2(1)`n' {
				local c1=`i'-1
				replace type=`ng' in `i'
				if label[`i']!=label[`c1'] {
					local ng=`ng'+1
					local t`ng'= label[`i']
					replace type=`ng' in `i'
					}
				}
replace type=6969 if label=="ZZ" /*exclusion del grupo labeled ZZ*/
local mute=0
forvalues i=2(1)`n' {
	if label[`i']=="ZZ" local mute=1
	}
if `mute'==1 local ng=`ng'-1					
sort orden
drop orden
}
/*fin*/

/*crea la leyenda*/
if `ng'==1 local leyenda "5 "`t1'""
if `ng'==2 local leyenda "5 "`t1'" 6 "`t2'""
if `ng'==3 local leyenda "5 "`t1'" 6 "`t2'" 7 "`t3'""
if `ng'==4 local leyenda "5 "`t1'" 6 "`t2'" 7 "`t3'" 8 "`t4'""
if `ng'==5 local leyenda "5 "`t1'" 6 "`t2'" 7 "`t3'" 8 "`t4'" 9 "`t5'""
if `ng'==6 local leyenda "5 "`t1'" 6 "`t2'" 7 "`t3'" 8 "`t4'" 9 "`t5'" 10 "`t6'""
if `ng'==7 local leyenda "5 "`t1'" 6 "`t2'" 7 "`t3'" 8 "`t4'" 9 "`t5'" 10 "`t6'" 11 "`t7'""
/*fin*/


capture drop x_a- controlpunto

display as text ". To stop plotting, type " as error "out" as text " as Y coordinate"
display
display
/*seleccion de variables, "out" aborta el programa*/
local sigo 0 /*variable de control*/
while `sigo' ==0 {
	local leftcoor "junk"
	capture confirm numeric variable `leftcoor'
	if "`leftcoor'"=="out" local sigo=1
	while _rc!=0 & `sigo'==0 {
		display as result". Left coordinate? (type or double-click in the variables window) " _cont
		display _request(_leftcoor)
		capture confirm numeric variable `leftcoor'
		if "`leftcoor'"=="out" local sigo=1
		}
	local rightcoord "junk"
	capture confirm numeric variable `rightcoor' 
	while _rc!=0 & `sigo'==0{
		display as result". Right coordinate? (type or double-click in the variables window) "_cont
		display _request(_rightcoor)
		capture confirm numeric variable `rightcoor'
		}	
	capture confirm numeric variable `uppercoor' 
	while _rc!=0 & `sigo'==0{
		display as result". Upper coordinate? (type or double-click in the variables window) " _cont
		display _request(_uppercoor)
		capture confirm numeric variable `uppercoor'
		}					
	
	
	/*creo las coordenadas de los puntos*/
if "`leftcoor'"!="out" {/*if mayor*/

	quietly{
	gen x_a=100*(0.5-`leftcoor'/(`leftcoor'+`rightcoor'))
	gen ycoor=86.6*`uppercoor'/(`uppercoor'+`leftcoor'+`rightcoor')
	gen xcoor=50+x_a-(x_a*ycoor/86.6)
	
	
	/* creo las coordenadas del dibujo*/
	local nobs=_N
	local newobs=`nobs' + 35
	set obs `newobs'
	gen labelpunto=""
	gen controlpunto=.
	
	/*punto1*/
	local i= `nobs' + 1
	local begindelete=  `nobs' + 1
	replace xcoor=0 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=10 in `i'
	/*punto2*/
	local i= `nobs' + 2
	replace xcoor=100 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=10 in `i'
	/*punto3*/
	local i= `nobs' + 3
	replace xcoor=50 in `i'
	replace ycoor=86.6 in `i'
	replace controlpunto=10 in `i'
	/*punto4*/
	local i= `nobs' + 4
	replace xcoor=0 in `i' 
	replace ycoor=0 in `i'
	replace controlpunto=10 in `i'
	/*punto5*/
	local i= `nobs' + 5
	replace xcoor=0 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="100" in `i' 
	/*punto6*/
	local i= `nobs' + 6
	replace xcoor=10 in `i' 
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i' 
	replace labelpunto="90" in `i'
	/*punto7*/
	local i= `nobs' + 7
	replace xcoor=20 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="80" in `i'
	/*punto8*/
	local i= `nobs' + 8
	replace xcoor=30 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="70" in `i'
	/*punto9*/
	local i= `nobs' + 9
	replace xcoor=40 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="60" in `i'
	/*punto10*/
	local i= `nobs' + 10
	replace xcoor=50 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="50" in `i'
	/*punto11*/
	local i= `nobs' + 11
	replace xcoor=60 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="40" in `i'
	/*punto12*/
	local i= `nobs' + 12
	replace xcoor=70 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="30" in `i'
	/*punto13*/
	local i= `nobs' + 13
	replace xcoor=80 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="20" in `i'
	/*punto14*/
	local i= `nobs' + 14
	replace xcoor=90 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="10" in `i'
	/*punto15*/
	local i= `nobs' + 15
	replace xcoor=100 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="0" in `i'
	/*punto16*/
	local i= `nobs' + 16
	replace xcoor=5 in `i'
	replace ycoor=8.66 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="10" in `i'
	/*punto17*/
	local i= `nobs' + 17
	replace xcoor=10 in `i'
	replace ycoor=17.32 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="20" in `i'
	/*punto18*/
	local i= `nobs' + 18
	replace xcoor=15 in `i'
	replace ycoor=25.98 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="30" in `i'
	/*punto19*/
	local i= `nobs' + 19
	replace xcoor=20 in `i'
	replace ycoor=34.64 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="40" in `i'
	/*punto20*/
	local i= `nobs' + 20
	replace xcoor=25 in `i'
	replace ycoor=43.3 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="50" in `i'
	/*punto21*/
	local i= `nobs' + 21
	replace xcoor=30 in `i'
	replace ycoor=51.86 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="60" in `i'
	/*punto22*/
	local i= `nobs' + 22
	replace xcoor=35 in `i'
	replace ycoor=60.622 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="70" in `i'
	/*punto23*/
	local i= `nobs' + 23
	replace xcoor=40 in `i'
	replace ycoor=69.282 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="80" in `i'
	/*punto24*/
	local i= `nobs' + 24
	replace xcoor=45 in `i'
	replace ycoor=77.9422 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="90" in `i'
	/*punto25*/
	local i= `nobs' + 25
	replace xcoor=49.9 in `i'
	replace ycoor=86.6 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="100" in `i'
	/*punto26*/
	local i= `nobs' + 26
	replace xcoor=95 in `i'
	replace ycoor=8.66 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="90" in `i'
	/*punto27*/
	local i= `nobs' + 27
	replace xcoor=90 in `i'
	replace ycoor=17.32 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="80" in `i'
	/*punto28*/
	local i= `nobs' + 28
	replace xcoor=85 in `i'
	replace ycoor=25.98 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="70" in `i'
	/*punto29*/
	local i= `nobs' + 29
	replace xcoor=80 in `i'
	replace ycoor=34.64 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="60" in `i'
	/*punto30*/
	local i= `nobs' + 30
	replace xcoor=75 in `i'
	replace ycoor=43.3 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="50" in `i'
	/*punto31*/
	local i= `nobs' + 31
	replace xcoor=70 in `i'
	replace ycoor=51.86 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="40" in `i'
	/*punto32*/
	local i= `nobs' + 32
	replace xcoor=65 in `i'
	replace ycoor=60.622 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="30" in `i'
	/*punto33*/
	local i= `nobs' + 33
	replace xcoor=60 in `i'
	replace ycoor=69.282 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="20" in `i'
	/*punto34*/
	local i= `nobs' + 34
	replace xcoor=55 in `i'
	replace ycoor=77.94 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="10" in `i'
	/*punto35*/
	local i= `nobs' + 35
	replace xcoor=50 in `i'
	replace ycoor=86.6 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="0" in `i'
	
	} /*del quietly*/
	


/*escoge si proyecta identificadores de las muestras*/

	if $ids== 0 { /*no identificadores*/
		twoway (connected ycoor xcoor if controlpunto==10, msymbol(none) lcolor(black)) (scatter ycoor xcoor if controlpunto==9, msymbol(circle) mcolor(black) msize(tiny) mlabel(labelpunto) mlabcolor(black) mlabposition(6)) (scatter ycoor xcoor if controlpunto==8, msymbol(circle) mcolor(black) msize(tiny) mlabel(labelpunto) mlabcolor(black) mlabposition(10))(scatter ycoor xcoor if controlpunto==7, msymbol(circle) mcolor(black) msize(tiny) mlabel(labelpunto) mlabcolor(black) mlabposition(2)) (scatter ycoor xcoor if type==1, msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, msymbol($symbol7) msize($size7) mcolor($color7)), yscale(range(-10 110) off) xscale(range(-10 110) off) ysize(6) xsize(6) graphregion(margin(large)) text(-8 0 "`leftcoor'") text(4 103 "`rightcoor'") text(95 49 "`uppercoor'") title(ternary scatter plot) legend(cols(1) order("`leyenda'")) legend(position(2) ring(0)) fysize(100) fxsize(150)  name("tri_plot", replace) plotregion(lcolor(black))
		}
	else{
		twoway (connected ycoor xcoor if controlpunto==10, msymbol(none) lcolor(black)) (scatter ycoor xcoor if controlpunto==9, msymbol(circle) mcolor(black) msize(tiny) mlabel(labelpunto) mlabcolor(black) mlabposition(6)) (scatter ycoor xcoor if controlpunto==8, msymbol(circle) mcolor(black) msize(tiny) mlabel(labelpunto) mlabcolor(black) mlabposition(10))(scatter ycoor xcoor if controlpunto==7, msymbol(circle) mcolor(black) msize(tiny) mlabel(labelpunto) mlabcolor(black) mlabposition(2)) (scatter ycoor xcoor if type==1, mlabel(id) mlabcolor(black) msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, mlabel(id) mlabcolor(black) msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, mlabel(id) mlabcolor(black) msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, mlabel(id) mlabcolor(black) msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, mlabel(id) mlabcolor(black) msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, mlabel(id) mlabcolor(black) msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, mlabel(id) mlabcolor(black) msymbol($symbol7) msize($size7) mcolor($color7)), yscale(range(-10 110) off) xscale(range(-10 110) off) ysize(6) xsize(6) graphregion(margin(large)) text(-8 0 "`leftcoor'") text(4 103 "`rightcoor'") text(95 49 "`uppercoor'") title(ternary scatter plot) legend(cols(1) order("`leyenda'")) legend(position(2) ring(0)) fysize(100) fxsize(150)  name("labeled_tri_plot", replace) plotregion(lcolor(black))
		}
		local leftcoor "junk"
		local rightcoor "junk"
		local uppercoor "junk"
		quietly{
		drop x_a- controlpunto
		drop in `begindelete'/`newobs'
			}
		display""
		display"NEW ENTRY"
		display""

 }/*del if mayor*/	
}/*del primer while*/
drop type
display
display as text ". Done ternary plots"

end
	
	
