program define igpetools

version 10
display
display
display
display
display as text". USEFUL PLOTS FOR IGNEOUS ROCKS, by F. Bea (2008); v. 3.0"
display
display as text". THE ELEMENT AND PARAMETER PLOTING ROUTINES CAN PLOT UP TO SEVEN GROUPS"
display as text". WITH DIFFERENT SYMBOLS. THEY USE ONE GROUPING VARIABLE" as error" -label-" as text" TO BUILD THE LEGEND"
display as text". THE VARIABLES NAMES" as error" -type, out, pause, resume plot, xcoor, ycoor or zcoor-"as text" ARE RESERVED"
display as text". DO NOT USE THEM"
display
display
display as text". REQUIREMENTS FOR THE DATA FILE:"
display as text". 1.- Total iron must be as FeO"
display as text". 2.- Variables must be named by the element symbol in lower-case letters:"as error" si, ti, zr, la, etc."
display as text". 3.- Major elements can be labeled as"as error" SiO2, TiO2, etc."as text" using the appropiate submenu."
display as text". 4.- The first variable stores the sample identification. It must be named"as error" -id-"as text"."
display as text".     It must contain just letters and numbers:"as error" b1 or C123 are valid. C-11 or a+g are not"as text"."
display as text". 5.- The"as error" -label-"as text" variable should be (but does not have to be) the last of the file."
display as text".     It is convenient to use just two characters, always in CAPITALS. The label" as error" -ZZ-"as text" does not plot."
display as text". 6.- It plots up to 7 labels. Colors, symbols, plot dimensions and plotting identifiers can be changed in menus."

/*la variable global ids controla si se proyectan identificadores de cada muestra*/
global ids = 0 
/*la variable global bisectriz controla si en los diagramas binarios ponemos una bisectriz, el defecto (0) es que no; 1 es que si*/
global bisectriz=0 /*por defecto sin bisectriz*/
global legend=1/*por defecto con leyenda*/

/*simbols and colors*/
global symbol1 circle
global color1 black
global size1 large

global symbol2 plus
global color2 red
global size2 vlarge

global symbol3 square
global color3 blue
global size3 medlarge

global symbol4 diamond
global color4 midgreen
global size4 medlarge

global symbol5 circle
global color5 gold
global size5 large

global symbol6 circle
global color6 magenta
global size6 large

global symbol7 diamond
global color7 lavender
global size7 medlarge

global a_xsize=5.5
global is_changed=0
global y_orientation="horizontal"
global resume="junk" /*reinicia programas detenidos con pause*/


	window menu clear
	window menu append submenu "stUser" "IgPeTools"
	window menu append separator "IgPeTools"
	window menu append item "IgPeTools" "label major elements" "gq_label_me"
	window menu append item "IgPeTools" "element parameters" "gq_el_par"
	window menu append separator "IgPeTools"
	window menu append item "IgPeTools" "binary plots" "gq_bi_plot"
	window menu append item "IgPeTools" "ternary plots" "gq_tri_plot"
	window menu append separator "IgPeTools"
	window menu append item "IgPeTools" "TAS plot" "gq_tas_plot"
	window menu append item "IgPeTools" "AFM plot" "gq_afm_plot"
	window menu append item "IgPeTools" "K2O vs SiO2 plot" "gq_sik_plot"
	window menu append item "IgPeTools" "Peacok plot" "gq_peacok"
	window menu append item "IgPeTools" "Ritmann-Gottini plot" "gq_rg_plot"
	window menu append item "IgPeTools" "Bea granite-discrimination plots" "gq_fdgra"
	window menu append item "IgPeTools" "Frost plots" "gq_frost_plot"
	window menu append item "IgPeTools" "Borodin plot" "gq_borodin"
	window menu append item "IgPeTools" "Whalen-Eby plots" "gq_whalen_eby_plot"
	window menu append separator "IgPeTools"
	window menu append item "IgPeTools" "Chondrite normalized REE plot" "gq_ree_plot"
	window menu append item "IgPeTools" "Silicate Earth normalized plot" "gq_siliearth_plot"
	window menu append item "IgPeTools" "Silicate Earth normalized plot (reduced)" "gq_siliearth_red_plot"
	window menu append item "IgPeTools" "N-MORB normalized plot" "gq_nmorb_plot"
	window menu append item "IgPeTools" "Continental Crust normalized plot" "gq_cc_plot"
	window menu append separator "IgPeTools"
	window menu append item "IgPeTools" "Toggle plotting sample identifiers" "gq_toggle_ids"
	window menu append item "IgPeTools" "Toggle bisectriz (binary plots)" "gq_toggle_bisectriz"
	window menu append item "IgPeTools" "Toggle Y label orientation" "gq_toggle_yorientation"
	window menu append item "IgPeTools" "Toggle legend" "gq_toggle_legend"
	window menu append separator "IgPeTools"
	window menu append item "IgPeTools" "Change group symbols" "gq_change_symbols"
	window menu append item "IgPeTools" "Reset group symbols" "gq_reset_symbols"
	window menu append separator "IgPeTools"	
	window menu append item "IgPeTools" "Change plot width" "gq_plot_width"
	window menu refresh
	display
	display as text". Ready"
	display
end

